{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program Foolish;

type float = double;
     Toper = (_add, _sub, _mul);
     ExpType = (_Max, _Min, _No);
const Infinity = 1e30;

var Vx, Vn: array [1..53,1..53] of float;
    ln, rn, lx, rx: array [1..53, 1..53] of ExpType;
    pn, px: array [1..53, 1..53] of byte;
    n: integer;
   op: array [1..53] of Toper;
    MinNo, MaxNo: byte;

procedure ReadAll;
var s, s1: string;
    l, i, j: integer;
begin
  assign (input, 'input.txt'); reset (input);
  readln (input, s);
  for i := 1 to 53 do
    for j := 1 to 53 do
    begin
      vx [i, j] := -Infinity;
      vn [i, j] := Infinity;
      rx [i, j] := _no;
      lx [i, j] := _no;
      px [i, j] := 0;
      pn [i, j] := 0;
      rn [i, j] := _no;
      ln [i, j] := _no;
    end;
  l := 1;
  s[length(s)+1] := '+';
  n := 0;
  for i := 1 to length(s)+1 do
  if (s[i] in ['*','+','-']) and (not ( (i>1) and (upcase(s[i-1])='E') ))
  then
  begin
    inc (n);
    s1 := copy (s, l, i-l);
    l := i+1;
    while s1[byte(s1[0])] = ' ' do dec (s1[0]);
    while s1[1] = ' ' do s1 := copy (s1,2, length(s1)-1);
    if upcase(s1[length(s1)]) = 'E' then s1 := s1 + '+0';
    Val (s1, vx[n,n], j);
    vn[n, n] := vx [n,n];
    if s[i] = '*' then op [n] := _mul;
    if s[i] = '+' then op [n] := _add;
    if s[i] = '-' then op [n] := _sub;
  end;
  close (input);
end;

function min4 (a, b, c, d: float): float;
var x: float;
begin
  x := a; MinNo := 1;
  if b < x then begin x := b; MinNo := 2; end;
  if c < x then begin x := c; MinNo := 3; end;
  if d < x then begin x := d; MinNo := 4; end;
  min4 := x;
end;

function max4 (a, b, c, d: float): float;
var x: float;
begin
  x := a; MaxNo := 1;
  if b > x then begin x := b; MaxNo := 2; end;
  if c > x then begin x := c; MaxNo := 3; end;
  if d > x then begin x := d; MaxNo := 4; end;
  max4 := x;
end;

procedure CalcPart (x, y: integer);
var fmin, fmax, f1, f2, h1, h2, h3, h4: float;
    i, j: integer;
    lrx, llx, lrn, lln: ExpType;
    lpx, lpn: integer;
    crx, clx,crn, cln: ExpType;
begin
  fmax := -Infinity;
  fmin := +Infinity;
  for i := x to y-1 do
  begin
    case op [i] of
      _add: begin
              f1 := vn[x,i] + vn[i+1,y];
              f2 := vx[x,i] + vx[i+1,y];
              clx := _max;
              crx := _max;
              cln := _min;
              crn := _min;
            end;
      _sub: begin
              f1 := vn[x,i] - vx[i+1,y];
              f2 := vx[x,i] - vn[i+1,y];
              clx := _max;
              crx := _min;
              cln := _min;
              crn := _max;
            end;
      _mul: begin
              h1 := vx[x,i] * vx[i+1,y];
              h2 := vx[x,i] * vn[i+1,y];
              h3 := vn[x,i] * vx[i+1,y];
              h4 := vn[x,i] * vn[i+1,y];
              f1 := Min4 (h1, h2, h3, h4);
                case MinNo of
                  1:begin
                      cln := _Max;
                      crn := _Max;
                    end;
                  2:begin
                      cln := _Max;
                      crn := _Min;
                    end;
                  3:begin
                      cln := _Min;
                      crn := _Max;
                    end;
                  4:begin
                      cln := _Min;
                      crn := _Min;
                    end;
                end;
              f2 := Max4 (h1, h2, h3, h4);
                case MaxNo of
                  1:begin
                      clx := _Max;
                      crx := _Max;
                    end;
                  2:begin
                      clx := _Max;
                      crx := _Min;
                    end;
                  3:begin
                      clx := _Min;
                      crx := _Max;
                    end;
                  4:begin
                      clx := _Min;
                      crx := _Min;
                    end;
                end;
            end;
    end; {case}
    if f1 < Fmin then
         begin
           Fmin := f1;
           lln := cln;
           lrn := crn;
           lpn := i;
         end;
    if f2 > Fmax then
         begin
           Fmax := f2;
           llx := clx;
           lrx := crx;
           lpx := i;
         end;
  end;
  vn [x, y] := fmin;
  vx [x, y] := fmax;
  ln [x, y] := lln;
  rn [x, y] := lrn;
  pn [x, y] := lpn;
  lx [x, y] := llx;
  rx [x, y] := lrx;
  px [x, y] := lpx;
end;

procedure BuildTable;
var l, i, j: integer;
begin
  for l := 2 to n do
    for i := 1 to n-l+1 do
      CalcPart (i, i+l-1);
end;

procedure WriteMax (x, y: integer; lev: integer); forward;

procedure WriteMin (x, y: integer; lev: integer);
var i, j: integer;
begin
  if x = y then
       begin
         write (vn[x,y]{:10:10});
         exit;
       end;
  if lev > 0 then write('(');
  if ln [x, y] = _Max then WriteMax (x, pn[x, y], lev + 1)
                      else WriteMin (x, pn[x, y], lev + 1);
  case op[pn[x,y]] of
    _add: write ('+');
    _sub: write ('-');
    _mul: write ('*');
  end;
  if rn [x, y] = _Max then WriteMax (pn[x, y]+1, y, lev + 1)
                      else WriteMin (pn[x, y]+1, y, lev + 1);
  if lev > 0 then write(')');
end;

procedure WriteMax (x, y: integer; lev: integer);
var i, j: integer;
begin
  if x = y then
       begin
         write (vx[x,y]{:10:10});
         exit;
       end;
  if lev > 0 then write('(');
  if lx [x, y] = _Max then WriteMax (x, px[x, y], lev + 1)
                      else WriteMin (x, px[x, y], lev + 1);
  case op[px[x,y]] of
    _add: write ('+');
    _sub: write ('-');
    _mul: write ('*');
  end;
  if rx [x, y] = _Max then WriteMax (px[x, y]+1, y, lev + 1)
                      else WriteMin (px[x, y]+1, y, lev + 1);
  if lev > 0 then write(')');
end;

procedure Solve;
begin
  BuildTable;
  assign (output, 'output.txt'); rewrite (output);
  WriteLn (vx [1,n]{:10:10});
  WriteMax (1, n, 0);
  close (output);
end;

begin
  ReadAll;
  Solve;
end.